{% extends 'profile/layouts/admin/admin_layout.html' %}

{% load static %}

{% block css %}
    <link rel="stylesheet" type="text/css" href="{% static 'profile/css/cropper/cropper.min.css' %}">
{% endblock css %}

{% block navbar %}
    {% include 'profile/layouts/admin/navbar.html' %}
{% endblock navbar %}

{% block main %}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{% url 'profile:admin_home' %}">Home</a></li>
            <li class="breadcrumb-item active" aria-current="page">Profile</li>
        </ol>
    </nav>

    {% if messages %}
        {% for message in messages %}
            <div class="alert {{ message.tags }} my-2" role="alert">
                {{message}}
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>  
        {% endfor %}
    {% endif %}
    
    <div class="row">
        <div class="col-md-4 col-sm-12 mb-2">
            <div class="card shadow">
                <div class="card-body p-3 text-center">
                        <div class="mb-3">
                            <img class="img-fluid rounded-circle mb-2" style="height: 60%; width: 60%; aspect-ratio: 1 / 1; object-fit: cover;" 
                                {% if user.avatar %}
                                    src="{{user.avatar.url}}"
                                {% else %}
                                    src="{% static '/admin/images/profile.png' %}"
                                {% endif %}
                                alt="Profile Picture">
                            <ul class="list-unstyled">
                                <li class="text-lg">{{ request.user.username }}</li>
                                <li class="text-sm">{{ request.user.role }}</li>
                                <li class="text-sm">{{ request.user.email }}</li>
                            </ul>
                            <button class="btn btn-info" id="avatar-ubah">Ubah Foto</button>
                        </div>

                        <div class="card" id="card-form-avatar">
                            <div class="card-header">Ganti Avatar</div>
                            <div class="card-body">
                                <form method ='post' enctype ="multipart/form-data" class="text-left"
                                    action="{% url 'profile:admin_user_avatar_edit' username=request.user.username %}">
                                        {% csrf_token %}
                                        <div class="form-group">
                                            <label for="avatar">Avatar</label>
                                            <input type="file" placeholder="Masukkan avatar"
                                                class="form-control"
                                                name="avatar"
                                                id="avatar"
                                                accept="image/png, image/jpeg, image/webp">
                                                <!-- {% if form.avatar.errors %}
                                                <div class="invalid-feedback">
                                                    {{ form.avatar.errors }}
                                                </div>
                                            {% endif %}
                                            {{form.x}}
                                            {{form.y}}
                                            {{form.width}}
                                            {{form.height}} -->
                                        </div>
                                        <button type="submit" class="btn btn-info">Submit</button>
                                </form>
                            </div>
                        </div>
                            
                </div>
            </div>
        </div>

        <div class="col-md-8 col-sm-12 mb-2">
            <div class="card shadow">
                <div class="card-body p-3">
                    <div class="row">
                        <div class="col-sm-3 text-dark text-lg font-weight-bold">Nama</div>
                        <div class="col-sm-9 text-secondary text-lg">{{ request.user.first_name }} {{ request.user.last_name }}</div>
                    </div>
                    <hr>

                    <div class="row">
                        <div class="col-sm-3 text-dark text-lg font-weight-bold">Email</div>
                        <div class="col-sm-9 text-secondary text-lg">{{ request.user.email }}</div>
                    </div>
                    <hr>

                    <div class="row">
                        <div class="col-sm-3 text-dark text-lg font-weight-bold">Telepon</div>
                        <div class="col-sm-9 text-secondary text-lg">{{ request.user.phone }}</div>
                    </div>
                    <hr>

                    <div class="row">
                        <div class="col-sm-3 text-dark text-lg font-weight-bold">TTL</div>
                        <div class="col-sm-9 text-secondary text-lg">{{ request.user.date_of_birth }}</div>
                    </div>
                    <hr>

                    <div class="row">
                        <div class="col-sm-3 text-dark text-lg font-weight-bold">Hak Akses</div>
                        <div class="col-sm-9 text-secondary text-lg">{{ request.user.role }}</div>
                    </div>
                    <hr>
                    <div class="text-right">
                        <a href="{% url 'profile:admin_user_edit' username=user.username %}" class="btn btn-info">Ubah Data Profile</a>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- <div class="row">
        <div class="col-md-12 col-sm-12 mb-2">
            <div class="card shadow">
                <div class="card-header m-0 font-weight-bold text-info">Statistik Konten</div>
                <div class="card-body p-3  d-flex justify-content-center">
                    <div class="col-md-8 col-sm-12">
                        <canvas id="myChart"></canvas>
                    </div>
                </div>
            </div>
        </div>
    </div> -->
<!-- MODAL TO CROP THE IMAGE -->
    <div class="modal fade" id="modalCrop" data-backdrop="static" data-keyboard="false">
        <div class="modal-dialog modal-lg">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="m-0 font-weight-bold text-info">Sesuaikan Foto</h5>
                    <button type="button" class="close text-info modal-close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>

                <div class="modal-body">
                    <img src="" id="image" style="max-width: 100%;">
                </div>

                <div class="modal-footer">
                <div class="btn-group pull-left" role="group">
                    <button type="button" class="btn btn-default js-zoom-in">
                        <i class="bi bi-zoom-in"></i>
                    </button>
                    <button type="button" class="btn btn-default js-zoom-out">
                        <i class="bi bi-zoom-out"></i>
                    </button>
                </div>
                <button type="button" class="btn btn-info js-crop-and-upload">Crop</button>
                </div>
            </div>
        </div>
    </div>

{% endblock main %}

{% block footer %}
    {% include 'profile/layouts/admin/footer.html' %}
{% endblock footer %}

{% block scripts_bawah %}
    <script src="{% static 'profile/js/cropper/cropper.min.js' %}"></script>
    <script src="{% static 'profile/js/cropper/jquery-cropper.min.js' %}"></script>
    <script src="{% static 'profile/js/chart.js' %}"></script>

    <script>
        $( document ).ready(function() {
            $("#card-form-avatar").hide();
        });

        $(".modal-close").click(function(){
            $("#id_avatar").val(null);
        });

        $("#avatar-ubah").click(function(){
            $("#card-form-avatar").toggle();
        });

        $("#id_avatar").change(function () {
            if (this.files && this.files[0]) {
                let reader = new FileReader();
                
                reader.onload = function (e) {
                    $("#image").attr("src", e.target.result);
                    $("#modalCrop").modal("show");
                }

                reader.readAsDataURL(this.files[0]);
            }
        });

        let $image = $("#image");
        let cropBoxData;
        let canvasData;

        $("#modalCrop").on("shown.bs.modal", function () {
            $image.cropper({
                viewMode: 1,
                aspectRatio: 1/1,
                minCropBoxWidth: 200,
                minCropBoxHeight: 200,
                ready: function () {
                    $image.cropper("setCanvasData", canvasData);
                    $image.cropper("setCropBoxData", cropBoxData);
            }
        });

        }).on("hidden.bs.modal", function () {
            cropBoxData = $image.cropper("getCropBoxData");
            canvasData = $image.cropper("getCanvasData");
            $image.cropper("destroy");
        });

        // Enable zoom in button
        $(".js-zoom-in").click(function () {
            $image.cropper("zoom", 0.1);
        });

        // Enable zoom out button
        $(".js-zoom-out").click(function () {
            $image.cropper("zoom", -0.1);
        });

        $("#avatar-ubah").click(function () {
            // var cropData = $image.cropper("getData");
            // $("#id_x").val(cropData["x"]);
            // $("#id_y").val(cropData["y"]);
            // $("#id_height").val(cropData["height"]);
            // $("#id_width").val(cropData["width"]);
            // $("#modalCrop").modal('hide');
            $("#form-avatar").submit();
        });
    </script>

    <script>
        const labels = [
            'Agenda',
            'Berita',
            'Dokumen Publikasi',
            'Galeri',
            'Pengumuman',
        ];
        const data = {
            labels: labels,
            datasets: [
                {   
                    label: 'Postingan Olehmu',
                    backgroundColor: 'rgb(13, 110, 253)',
                    borderColor: 'rgb(13, 110, 253)',
                    data: [{{agenda}}, {{news}}, {{document}}, {{gallery}}, {{announcement}}, ],
                },
                {
                    label: 'Total Postingan',
                    backgroundColor: 'rgb(32, 201, 151)',
                    borderColor: 'rgb(32, 201, 151)',
                    data: [{{agenda_total}}, {{news_total}}, {{document_total}}, {{gallery_total}}, {{announcement_total}},],
                },
            ]
        };
        const config = {
            type: 'bar',
            data: data,
            options: {
                indexAxis: 'y',
                responsive: true,
                scales: {
                    x: {
                        stacked: true,
                    },
                    y: {
                        stacked: true
                    }
                },
            }
        };
        const myChart = new Chart(
            document.getElementById('myChart'),
            config
        );
    </script>
{% endblock scripts_bawah %}

